﻿//////////////////////////////////////////////
// Viewport.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT Viewport
	{
		protected :			

			// Attributs
			// Le nom du Viewport
			std::string _name ;

			// Si dirty pour udpate
			// Les dimensions peuvent varier sans que la classe change
			bool _dirtyViewport ;
		
		public :
		
			// Constructeur, destructeur
			Viewport () ;
			virtual ~Viewport () ;

			// Getters
			virtual float getWidth () const = 0 ;
			virtual float getHeight () const = 0 ;
			virtual float getMinDepth () const = 0 ;
			virtual float getMaxDepth () const = 0 ;
			virtual float getTopLeftX () const = 0 ;
			virtual float getTopLeftY () const = 0 ;
			virtual nkMemory::StringView getName () const ;
			virtual bool getDirtyViewport () const ;

			// Setters
			virtual void setWidth (float width) = 0 ;
			virtual void setHeight (float height) = 0 ;
			virtual void setMinDepth (float value) = 0 ;
			virtual void setMaxDepth (float value) = 0 ;
			virtual void setTopLeftX (float value) = 0 ;
			virtual void setTopLeftY (float value) = 0 ;
			virtual void setName (const nkMemory::StringView& name) ;
			virtual void setDirtyViewport (bool value) ;
	} ;
}