﻿//////////////////////////////////////////////
// CursorManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Cursor ;
	class MainSystem ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/MaybeSingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT CursorManager final : public nkCommon::MaybeSingletonClass<CursorManager>
	{
		friend class nkCommon::MaybeSingletonClass<CursorManager> ;
		friend class MainSystem ;

		private :

			// Attributes
			// Memory
			std::unordered_map<std::string, Cursor*> _cursors ;

			// System
			MainSystem* _parentSystem ;

			// Active cursor
			Cursor* _activeCursor ;

		private :

			// Functions
			// Constructeur, destructeur
			CursorManager () ;
			CursorManager (MainSystem* parentSystem) ;
			~CursorManager () ;

		public :

			// Manipulation mémoire
			Cursor* createOrRetrieve (const nkMemory::StringView& name) ;
			Cursor* get (const nkMemory::StringView& name) const ;

			// Activation curseur
			void setActiveCursor (Cursor* cursor) ;
	} ;
}